/*
Local INdex maker "LIN" & "LIN-Win" (C) 1999-2013 Tatsuhiko Shoji
The sources for Local INdex maker "LIN" & "LIN-Win" are distributed under the MIT open source license
*/

#include	"encutil.h"

/**
 * Shift_JIS1ڂǂׂ
 *
 * @param n Ώە
 * @return 0:Shift_JIS1ڂł͂Ȃ !0:Shift_JIS1
 */
int isSJIS(unsigned char n)
{
	return((0x81<=n && n<=0x9F) ||  (0xE0<=n && n<=0xFC));
}

/**
 * Shift_JIS2ڂǂׂ
 *
 * @param n Ώە
 * @return 0:Shift_JIS2ڂł͂Ȃ !0:Shift_JIS2
 */
int isSJIS2(unsigned char n)
{
	return((0x40<=n && n<=0x7E) ||  (0x80<=n && n<=0xFC));
}


/**
 * EUC-JPŎg镶ǂׂ
 *
 * @param n Ώە
 * @return 0:EUC-JP̕ł͂Ȃ !0:EUC-JPŎg镶
 */
int iseuc(unsigned char n)
{
	return((n >= 0xa1) && (n < 0xff));
}

/**
 * UTF-8ǂ肷B
 *
 * @param s Ώە
 * @return 1:UTF-8łB 0:UTF-8ł͂ȂB
 */
int chkUTF8(char *s)
{
	int inEncoded,encCount;
	int utfFlag;
	char mask;

	inEncoded = 0;
	encCount = 0;
	utfFlag = 0;

	while(*s){
		if (inEncoded){
			/* 2oCgڈȍ~10??????łȂ΂ȂȂB */
			if (!((*s & 0xc0) == 0x80)){
				return 0;
			}else{
				encCount--;
				if (!encCount){
					/* GR[hꂽASCII͏IB */
					inEncoded = 0;
				}
			}
		}else{
			/* GR[hꂽ̒ł͂Ȃ */
			if (*s & 0x80){
				inEncoded = 1;
				if ((*s & 0xc0) == 0xc0){	/* 11xxxxxx */
					utfFlag = 1;
					encCount = 1;
				}else{
					/* 10??????ŏɂ邱Ƃ͂ȂB */
					return 0;
				}
				mask = (char)0xe0;
				while ((*s & mask) == mask){
					if (mask == 0xfe){
						/* 1oCgڂ0xfe,0xff͂肦ȂB */
						return 0;
					}
					encCount++;
					mask = mask >> 1;
					mask = mask | 0xf0;
				}
			}else{
				inEncoded = 0;
			}
		}
		s++;
	}
	if (utfFlag){
		return 1;
	}else{	/* 7bit only */
		return 0;
	}
}

/**
 * UTF-8Awchar_t(UCS-2)֕ϊB
 *
 * @param dst ϊobt@
 * @param str ϊ(UTF-8)
 */
size_t utf8towc(wchar_t *dst,const char *sr)
{
	wchar_t wc;
	unsigned char *src;
	int shift_count;
	int i;
	size_t convCount;

	src = (unsigned char *)sr;
	convCount = 0;

	while(*src){
		wc = 0;
		if (*src < 0x80){
			wc = *src;
			shift_count = 0;
		}else if (*src >= 0xfc){
			wc = *src & 0x01;
			shift_count = 5;
		}else if (*src >= 0xf8){
			wc = *src & 0x03;
			shift_count = 4;
		}else if (*src >= 0xf0){
			wc = *src & 0x07;
			shift_count = 3;
		}else if (*src >= 0xe0){
			wc = *src & 0x0f;
			shift_count = 2;
		}else if (*src >= 0xc0){
			wc = *src & 0x1f;
			shift_count = 1;
		}else{
			break;
		}

		src++;
		for (i = 0;i < shift_count;i++){
			if (*src == '\0'){
				wc = L'\0';
				break;
			}
			wc = wc << 6;
			wc = wc | (*src & 0x3f);
			src++;
		}
		if (dst != NULL){
			*dst = wc;
			dst++;
		}
		convCount++;
	}
	if (dst != NULL)
		*dst = L'\0';
	
	return convCount;
}

/**
 * UTF-8A}`oCg֕ϊB
 *
 * @param dst ϊobt@
 * @param str ϊ(UTF-8)
 * @param count ϊobt@̃TCY
 */
void utf8tomb(char *dst,char *str,int count)
{
	long len;
	wchar_t *witem;
	
	len = utf8towc(NULL,str);
	
	witem = (wchar_t *)malloc((len+1)*sizeof(wchar_t));
	if (witem == NULL)
		return;
	
	utf8towc(witem,str);
	wcstombs(dst,witem,count);
	
	free(witem);
}

/**
 * JIS,VJIS,pȂւ̑Ή̂߂̕ϊ֐
 *
 * @param s `FbNΏۂ̕
 * @param skiplen JISR[h̕
 * @return 0:{ 1:{Jn 2:ASCII/JIS[}Jn 3:JISJ^Ji
 */
int chkISO_2022_JP(unsigned char *s,int *skiplen)
{
	if (*s != 0x1b){
		*skiplen = 0;
		return(0);
	}
	s++;
	if (*s == '$'){
		s++;
		if ((*s == '@') || (*s == 'B')){	// 94^nW(TuZbg)G0ւ̎w old(JIS,VJIS)
			// Jn
			*skiplen = 3;
			return(1);
		}else if (*s == '('){	// 94^nW new
			s++;
			if ((*s == 'D') || (*s == '@') || (*s == 'B')){
				// ⏕('D'),(JIS '@',VJIS 'B')Jn
				*skiplen = 4;
				return(1);
			}else{
				// Ή94^n W({)
				*skiplen = 4;
				return(0);
			}
		}else{
			// Ή94^n W old( GB2312-80)
			*skiplen = 3;
			return(0);
		}
	}else if (*s == '('){	// 94WG0ւ̎w(TuZbg)
		s++;
		if ((*s == 'B') || (*s == 'J')){	// US-ASCII,JIS[}
			// ASCIIJn
			*skiplen = 3;
			return(2);
		}else if (*s == 'I'){	// JISJ^Ji
			// JISJ^JiJn
			*skiplen = 3;
			return(3);
		}else{
			// Ή94W
			*skiplen = 3;
			return(0);
		}
	}
	// Other escape sequence?
	*skiplen = 0;
	return(0);
}

/**
 * JISSHIFT_JIS֕ϊB
 *
 * @param c JIS
 * @return SHIFT_JIS
 */
unsigned jistoms(unsigned c)
{
	unsigned sjh,sjl,jh,jl;

	jh = (c >> 8);
	jl = c & 0xff;

	if (jh <= 0x5e){
		sjh = ((jh - 1) >> 1) + 0x71;
	}else{
		sjh = ((jh - 1) >> 1) + 0xb1;
	}

	if (jh % 2){
		sjl = jl + 0x1f;
		if (sjl >= 0x7f){
			sjl++;
		}
	}else{
		sjl = jl + 0x7e;
	}

	return((sjh << 8) | sjl);
}

// ISO-2000-JP -> Shift_JIS

int jisput(unsigned char *t,unsigned char *s)
{
	int stat,stFlag,LangType,skip,ostat;
	unsigned x;

	//fprintf(stderr,"!jisput\n");

	stat = 0;
	stFlag = 1;
	LangType = 0;
	while(*s){
		if (*s == 0x1b){
			LangType = chkISO_2022_JP(s,&skip);
			switch (LangType){
				case 1:	// JIS
					stat = 1;
				break;
				case 2:	// US-ASCII,JIS Roman
					stat = 0;
				break;
				case 3:	// JISJ^Ji
					stat = 2;
				break;
				default:
					*t = *s;
				break;
			}
			if (skip){
				s += (skip - 1);
			}
		}else{
			if (*s == SO){	// SO(G1W)
				ostat = stat;
				stat = 2;
			}else if (*s == SI){	// SI(G0W)
				stat = ostat;
			}else{
				if (stat == 1){	// JIS -> VtgJIS
					x = *s;
					s++;
					x = (x << 8) + *s;
					x = jistoms(x);
					*t = (x >> 8) & 0xff;
					t++;
					*t = x & 0xff;
					t++;
				}else if (stat == 2){	// JISJ^Ji(7bjt -> 8bit)
					if ((0x20 < *s) && (*s < 0x60)){	// 7bit pJi -> 8bit pJi
						*t = *s + 0x80;
					}else{	// ̂܂܏oB
						*t = *s;
					}
					t++;
				}else{	// 񊿎
					*t = *s;
					t++;
				}
			}
		}
		s++;
	}
	*t = '\0';
	return(stFlag);
}

/* JISR[hVtgJISʂB */
int chkjisms(unsigned char *s)
{
	int stat,LangType,skip,ostat;

	stat = 0;
	while(*s){
		if (*s == 0x1b){
			LangType = chkISO_2022_JP(s,&skip);
			switch (LangType){
				case 1:	// JIS
					stat = 1;
				break;
				case 2:	// US-ASCII,JIS Roman
					stat = 0;
				break;
				case 3:	// JISJ^Ji
					stat = 2;
				break;
			}
			if (skip){
				s += (skip - 1);
			}
		}else{
			if (*s == SO){	// SO(G1W)
				ostat = stat;
				stat = 2;
			}else if (*s == SI){	// SI(G0W)
				stat = ostat;
			}else{
				if (stat){ /* JIS 2bytes kanji */
					s++;
				}else{
					if (isSJIS(*s)){ /* Check Shift_JIS kanji code */
						s++;
						if (!isSJIS2(*s)){
							return(0);
						}
					}
				}
			}
		}
		s++;
	}
	return(1);
}


int eucput(unsigned char *t,unsigned char *s)
{
	int stat,LangType,skip,ostat;
	unsigned x;

	//fprintf(stderr,"!eucput\n");

	stat = 0;
	while(*s){
		if (*s == 0x1b){
			LangType = chkISO_2022_JP(s,&skip);
			switch (LangType){
				case 1:	// JIS
					stat = 1;
				break;
				case 2:	// US-ASCII,JIS Roman
					stat = 0;
				break;
				case 3:	// JISJ^Ji
					stat = 2;
				break;
				default:
					*t = *s;
				break;
			}
			if (skip){
				s += (skip - 1);
			}
		}else{
			if (*s == SO){	// SO(G1W)
				ostat = stat;
				stat = 2;
			}else if (*s == SI){	// SI(G0W)
				stat = ostat;
			}else{
				if (stat == 1){ /* JIS 2 bytes */
					x = *s;
					s++;
					x = (x << 8) + *s;
					x = jistoms(x);
					*t = (x >> 8) & 0xff;
					t++;
					*t = x & 0xff;
					t++;
				}else if (stat == 2){	// JISJ^Ji(7bjt -> 8bit)
					if ((0x20 < *s) && (*s < 0x60)){	// 7bit pJi -> 8bit pJi
						*t = *s + 0x80;
					}else{	// ̂܂܏oB
						*t = *s;
					}
					t++;
				}else{	// EUC
					if (*s < 0xa1){
						if (*s == 0x8e){	// pJ^Ji (ISO-2022Iɂ)VOVtg
							s++;
						}
						if (*s != 0x8f){	// ⏕ł͂Ȃ
							*t = *s;
							t++;
						}	// ⏕̏ꍇ͎̂QoCgEUC2oCgɂȂ
					}else{
						x = (*s & 0x7f);
						s++;
						x = (x << 8) + (*s & 0x7f);
						x = jistoms(x);
						*t = (x >> 8) & 0xff;
						t++;
						*t = x & 0xff;
						t++;
					}
				}
			}
		}
		s++;
	}
	*t = '\0';
	return(1);
}

/* JISR[hEUCR[hʂ */
int chkjiseuc(unsigned char *s)
{
	int stat,LangType,skip,ostat;

	stat = 0;
	while(*s){
		if (*s == 0x1b){
			LangType = chkISO_2022_JP(s,&skip);
			switch (LangType){
				case 1:	// JIS
					stat = 1;
				break;
				case 2:	// US-ASCII,JIS Roman
					stat = 0;
				break;
				case 3:	// JISJ^Ji
					stat = 2;
				break;
			}
			if (skip){
				s += (skip - 1);
			}
		}else{
			if (*s == SO){	// SO(G1W)
				ostat = stat;
				stat = 2;
			}else if (*s == SI){	// SI(G0W)
				stat = ostat;
			}else{
				if (stat){ /* JIS 2bytes kanji */
					s++;
				}else{
					if (!isascii(*s)){
						if (iseuc(*s)){ /* Check EUC_JP kanji code */
							s++;
							if (!iseuc(*s)){
								return(0);
							}
						}else if (*s == 0x8e){
							// pJ^Ji
							s++;
							if (!iseuc(*s)){
								return(0);
							}
						}else{
							return(0);
						}
					}
				}
			}
		}
		s++;
	}
	return(1);
}

