/*
Local INdex maker "LIN" & "LIN-Win" (C) 1999-2013 Tatsuhiko Shoji
The sources for Local INdex maker "LIN" & "LIN-Win" are distributed under the MIT open source license
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <time.h>
#include	<windows.h>

#include	"lin.h"
#ifdef LINWIN
#include	"linwin.h"
#endif

#include	"encutil.h"

/* HTMLߊ֘A */
/* ^Oߗp */
static unsigned char istag = 0;
static unsigned char tagbuf[256];
static unsigned char prevBuf[3];
static unsigned char *tagp;
static unsigned char isattr = 0;
static unsigned char iscomment = 0;
static int istitle;
static int taglen;
static char escbuf[5];
static char isG1;	/* JIS1oCgJ^JiH */
static int escCount;
static int secondByte;
static int doubleByteMode;	/* _uoCg[hH */
static int firstHTML;

/* WebA[JCu͏ */
static int isHTMLContent;
static int htmlStarted;
static int check_flag;
static char boundaryBuf[256];
static int isQuoted = 0;
static int isBase64 = 0;

/**********************/
/* HTMLt@C͌n */
/**********************/
/**
 * HTML̃^OȈՉ
 *
 * @return 0:HTMLǂ킩Ȃ 1:HTML^O 2:titlevfI
 */
int parseTag(void)
{
	if (tagbuf[1] == '/'){
		/* ^CgĂIĂB */
		if (_strnicmp(tagbuf+2,"title",5) == 0){
			istitle = 0;
			terminatetitle();
			return 2;
		}
	}else{
		if (_strnicmp(tagbuf+1,"title",5) == 0){
			istitle = 1;
			/* printf("Title found\n"); */
		}else if (_strnicmp(tagbuf+1,"html",4) == 0){	// ꉞHTMLł͂悤B
			return 1;
		}
	}
	return 0;
}

/* Gg̃^Ôobt@ɃRs[ */
void tagcpy(int c)
{
	int i;

	if (taglen < 255){
		*tagp = c;
		tagp++;
		taglen++;
	}
	for (i = 0;i < 2;i++){  // for comment check
		prevBuf[i] = prevBuf[i+1];
	}
	prevBuf[2] = c;
}

/**
 * (HTML)t@C̉
 *
 * @param c ͑Ώە
 * @return 0:܂HTMLǂ킩Ȃ 1:ȂƂHTMLł邱Ƃ킩B 2:^CgoB
 */
int checkHTML(int c)
{
	int i,result,skiplen,LangType;

	/* R[hʕ */

	if (escCount > 0) {
		/* ISO-2022GXP[vV[PX */
		escbuf[escCount] = c;
		escCount++;
		switch (escCount) {
			case 2:
				if ((c != '$') && (c != '(')) {
					// 2ڂłł߂ȃGXP[vV[PXƔB
					if (istitle){
						titlecpy(0x1b);
					}
					escCount = 0;
					doubleByteMode = 0;
					secondByte = 0;
					isG1 = 0;
				} else {
					return check_flag;
				}
				break;
			case 3:
				if (escbuf[1] == '(') {
					LangType = chkISO_2022_JP(escbuf,&skiplen);
					/* ̏ꍇ3ŃGXP[vV[PXB */
					if (LangType == 1){	// double byte mode
						doubleByteMode = 1;
						isG1 = 0;
						secondByte = 0;
					}else if ((LangType == 2) || (LangType == 3)){	// single byte mode
						doubleByteMode = 0;
						secondByte = 0;
						if (LangType == 3){
							isG1 = 1;
						}else{
							isG1 = 0;
						}
					}
					if (istitle) {
						/* ΉGXP[vV[PX낤ƁAISO-2022GXP[vV[PXɂȂ̂ŁA */
						/* ^Cgɓ */
						for (i = 0;i < skiplen;i++){
							titlecpy(escbuf[i]);
						}
					}
					escCount = 0;
				} else {
					/* 2ڂ'*'ƌ܂B */
					escbuf[3] = '\0';
					LangType = chkISO_2022_JP(escbuf,&skiplen);
					if (skiplen == 3) {
						if (LangType == 1){	// double byte mode
							doubleByteMode = 1;
							isG1 = 0;
							secondByte = 0;
						} else {
							doubleByteMode = 0;
							isG1 = 0;
							secondByte = 0;
						}
						if (istitle) {
							/* ΉGXP[vV[PX낤ƁAISO-2022GXP[vV[PXɂȂ̂ŁA */
							/* ^Cgɓ */
							for (i = 0;i < skiplen;i++){
								titlecpy(escbuf[i]);
							}
						}
						escCount = 0;
					}
				}
				return check_flag;
			case 4:
				LangType = chkISO_2022_JP(escbuf,&skiplen);
				if (LangType == 1){	// double byte mode
					doubleByteMode = 1;
					secondByte = 0;
					isG1 = 0;
				} else {
					doubleByteMode = 0;
					secondByte = 0;
					isG1 = 0;
				}
				if (istitle) {
					/* ΉGXP[vV[PX낤ƁAISO-2022GXP[vV[PXɂȂ̂ŁA */
					/* ^Cgɓ */
					for (i = 0;i < skiplen;i++){
						titlecpy(escbuf[i]);
					}
				}
				escCount = 0;
				return check_flag;
		}
	}

	if ((c == 0x1b) && (escCount == 0)) {
		/* GXP[vV[PXJn!? */
		escbuf[0] = 0x1b;
		escCount++;
		secondByte = 0;
		return check_flag;
	} else if (c == 0x0e) {
		/* JISpJiJn */
		isG1 = 1;
		secondByte = 0;
	} else if (c == 0x0f) {
		/* JISpJiI */
		isG1 = 0;
		secondByte = 0;
	}

	if (istag) {
		/* ^O̒ */
		if (c == '>' && isattr == 0 && isG1 == 0 && secondByte == 0){
			/* ^OI */
			tagcpy(c);
			if (iscomment){
				if (prevBuf[0] == '-' && prevBuf[1] == '-'){ /* Check comment end */
					*tagp = '\0';
					istag = 0;
					/* printf("Comment end\n"); */
				}
			}else{
				*tagp = '\0';
				istag = 0;
#if DEBUG
				printf("%s\n",tagbuf);
#endif
				result = parseTag();
				if (result){
					if (result > check_flag){
						check_flag = result;
						if (check_flag == 2) {
							/* titleI */
						}
					}
				}
			}
		} else {
			/* ^OĂ */
			if (isG1 == 0){
				switch (c){
					case 0x22:	/* " oƂ͑lǂmF */
						if (!iscomment) {
							isattr = 1 - isattr;
						}
					break;
					case '<':	/* łȂ̂<oꍇ͍܂ł̃^OLq~XƂĔjB */
						if (!isattr){	/* lłȂ̂<oĂ */
							tagcpy('\0');
							if (istitle){
								/* ׂvf̏ꍇ */
								/* ܂ł̕obt@ɓB */
								titlecat(tagbuf);
								/* ^Oobt@Zbg */
								taglen = 0;
								tagp = tagbuf;
							}
						}
					break;
				}
			}
			tagcpy(c);
			if (taglen == 4){ /* Check comment start */
				if (tagbuf[1] == '!'){
					if (tagbuf[2] == '-' && tagbuf[3] == '-'){
						iscomment = 1;
						/* printf("Comment\n"); */
					}
				}
			}
		}
		prevBuf[0] = prevBuf[1];
		prevBuf[1] = c;
	} else {
		/* ^O̊O */
		if ((c == '<') && (!isG1) && (!doubleByteMode)){
			/* ^OJn */
			istag = 1;
			iscomment = 0;
			isattr = 0;
			taglen = 0;
			tagp = tagbuf;
			tagcpy(c);
		} else if (istitle){
			titlecpy(c);
		}
	}

	if (doubleByteMode){	// JIS2oCg[h
		if (secondByte) {
			/* 2oCgڂ玟1oCg */
			secondByte = 0;
		} else {
			/* 1oCgڂ玟2oCg */
			secondByte = 1;
		}
	}

	return check_flag;

}

/**
 * quoted-printable̍sfR[hB<br>
 *
 * @param line fR[hs
 */
void decodeQuoted(char *line)
{
	char *p;
	char *p2;
	char c1;
	char c2;
	unsigned int qc;

	/* Quoted-Printablẻ */
	p = line;
	p2 = line;
	while(*p) {
		if (*p == '=') {
			/* \tgs(=ōsI)ǂ肷B */
			if (*(p + 1) == '\n') {
				break;
			}
			if (*(p + 1) == '\0') {
				break;
			}
			c1 = *(p + 1);
			if (isxdigit(c1)) {
				c2 = *(p + 2);
				if (isxdigit(c2)) {
					c1 = toupper(c1);
					c2 = toupper(c2);
					qc = 0;
					if (isalpha(c1)) {
						qc = c1 - 'A' + 10;
					} else {
						qc = c1 - '0';
					}
					qc = qc << 4;
					if (isalpha(c2)) {
						qc = qc + (c2 - 'A' + 10);
					} else {
						qc = qc + (c2 - '0');
					}
					if (qc < 128) {
						*p2 = qc;
					} else {
						qc = qc & 0xff;
						*p2 = qc - 256;
					}
					p2++;
					p += 3;
				} else {
					*p2 = *p;
					p++;
					p2++;
				}
			} else {
				*p2 = *p;
				p++;
				p2++;
			}
		} else {
			*p2 = *p;
			p++;
			p2++;
		}
	}
	*p2 = '\0';
}

/* Base64ϊpe[u */
static char base64Table[64] = {
	'A',
	'B',
	'C',
	'D',
	'E',
	'F',
	'G',
	'H',
	'I',
	'J',
	'K',
	'L',
	'M',
	'N',
	'O',
	'P',
	'Q',
	'R',
	'S',
	'T',
	'U',
	'V',
	'W',
	'X',
	'Y',
	'Z',
	'a',
	'b',
	'c',
	'd',
	'e',
	'f',
	'g',
	'h',
	'i',
	'j',
	'k',
	'l',
	'm',
	'n',
	'o',
	'p',
	'q',
	'r',
	's',
	't',
	'u',
	'v',
	'w',
	'x',
	'y',
	'z',
	'0',
	'1',
	'2',
	'3',
	'4',
	'5',
	'6',
	'7',
	'8',
	'9',
	'+',
	'/'
};

/**
 * Base64ϊ̕ϊO6bit擾B
 *
 * @param Base64
 * @return ɑΉ6bit
 */
int getBit(char c)
{
	int i;

	for (i = 0; i < 64; i++) {
		if (c == base64Table[i]) {
			return i;
		}
	}
	return 0;
}

/**
 * quoted-printable̍sfR[hB<br>
 * lineŎw肵̒g̓fR[h̓eɒuB
 *
 * @param line fR[hs
 */
void decodeBase64(char *line)
{
	char buf[5],*p;
	int len,now,c,bit;

	buf[4] = '\0';
	len = strlen(line);
	now = 0;
	p = line;
	while(1) {
		if ((now + 4) < len) {
			memcpy(buf, line + now, 4);
		} else {
			break;
		}
		c = 0;
		if (buf[0] != '=') {
			/* 6bit */
			c = getBit(buf[0]);
			c <<= 2;
		}
		if (buf[1] != '=') {
			/* 2bit */
			bit = getBit(buf[1]);
			c = c | ((bit >> 4) & 0x03);
			*p = c;
			p++;
			/* 4bit */
			c = (bit << 4);
		} else {
			break;
		}
		if (buf[2] != '=') {
			/* 4bit */
			bit = getBit(buf[2]);
			c = c | ((bit >> 2) & 0x0f);
			*p = c;
			p++;
			/* 2bit */
			c = (bit << 6);
		} else {
			break;
		}
		if (buf[3] != '=') {
			/* 2bit */
			bit = getBit(buf[3]);
			c = c | (bit & 0x3f);
			*p = c;
			p++;
		} else {
			break;
		}

		now += 4;
	}
	*p = '\0';
}

/**
 * ǂݍ񂾍s͂B
 *
 * @param line ߂s
 * @return 0:HTMLJn/IȊO 1:HTMLJn 2:titlevfI
 */
int parseLine(char *line)
{
	char *boundary;
	int len;
	char *p;

	len = strlen(line);
	if (len == 0) {
		/* s̎̓wb_̉\B */
		if ((isHTMLContent) && (htmlStarted == 0)) {
			htmlStarted = 1;
			/* printf("HTML body start\n"); */
			return 1;
		}
		return 0;
	}

	if (isQuoted) {
		/* Quoted-PrintablẽfR[h */
		decodeQuoted(line);
	}

	if (strstr(line,"Content-Type:") != NULL) {
		/* printf("Content-Type\n"); */

		isHTMLContent = 0;
		if (strstr(line,"multipart/related") != NULL) {
			/* printf("Contents is multipart.\n"); */

			boundary = strstr(line,"boundary=");
			if (boundary != NULL) {
				strcpy(boundaryBuf,boundary + 9);
				/* printf("boundary:%s\n",boundaryBuf); */
			}
		} else if (strstr(line,"text/html") != NULL) {
			/* RecHTML */
			if (firstHTML) {
				/* printf("Contents is also HTML.\n"); */
			} else {
				isHTMLContent = 1;
				htmlStarted = 0;
				/* printf("Contents is first HTML.\n"); */
				return 1;
			}
		} else {
			/* printf("Contents isn't HTML.\n"); */
		}
	}
	if (strstr(line, "Content-Transfer-Encoding:") != NULL) {
		p = strchr(line, ':');
		p++;
		while(*p) {
			if (strnicmp(p, "Quoted-Printable", 16) == 0) {
				isQuoted = 1;
				break;
			}
			if (strnicmp(p, "base64", 6) == 0) {
				isBase64 = 1;
				break;
			}
			p++;
		}
	}

	if (line[0] == '-') {
		if (len > 2) {
			if (!strcmp(boundaryBuf,line + 2)) {
				/* oE_ɍvB */
				/* printf("Contents end.\n"); */

				if (isHTMLContent) {
					/* HTML͏IB */
					isHTMLContent = 0;
					htmlStarted = 0;
					/* printf("HTML body end.\n"); */
					return 2;
				} else {
					isHTMLContent = 0;
					htmlStarted = 0;
					return 0;
				}
				isQuoted = 0;
				isBase64 = 0;
			}
		}
	}
	return 0;
}

/**
 * sHTML߃[`ɓn
 *
 * @param buf ߂s
 * @return 0:HTMLJn/IȊO 1:HTMLJn 2:titlevfI
 */
int checkBuf(char *buf)
{
	int i,len,result,c,j,isValid;

	if (isBase64) {
		/* Base64̃fR[h */
		decodeBase64(buf);
	}
	result = 0;
	len = strlen(buf);

	/* HTMLߒ͉߃[`ɓnB */
	for (i = 0; i < len;i++) {
		c = buf[i];
		if (isQuoted) {
			/* quoted-printableƂ̓fR[hKvB */
			if (buf[i] == '=') {
				if ((i + 2) < len) {
					isValid = 1;
					for (j = 0; j < 2;j++) {
						if (!isxdigit(buf[i + 1 + j])) {
							isValid = 0;
						}
					}
					if (isValid) {
						i++;
						c = 0;
						if (isalpha(buf[i])) {
							c = toupper(buf[i]) - 'A' + 10;
						} else {
							c = buf[i] - '0';
						}
						c = c << 4;
						i++;
						if (isalpha(buf[i])) {
							c = c + (toupper(buf[i]) - 'A' + 10);
						} else {
							c = c + (buf[i] - '0');
						}
					}
				}
			}
		}
		result = checkHTML(c);
		if (result == 2) {
			return result;
		}
	}
	escCount = 0;
	secondByte = 0;

	return result;
}

/**
 * MHT(ML)̉
 *
 * @param dir_name fBNg
 * @param filename t@C
 * @return -1:͒ɃG[ 0:HTMLłȂ 1:HTMLJn 2:titlevfoB
 */
int CheckMHTML(char *dir_name,char *filename)
{
	int lineType,inHTML;
	FILE *fpi;
	char *fnbuf,msgbuf[300];
	unsigned char *lineBuf;
	char *isEof;
	int result;

	/* ÓIϐ̏ */
	istag = 0;
	istitle = 0;
	isattr = 0;
	iscomment = 0;
	taglen = 0;
	doubleByteMode = 0;
	check_flag = 0;
	isG1 = 0;
	escCount = 0;
	secondByte = 0;
	firstHTML = 0;
	isQuoted = 0;
	isBase64 = 0;

	boundaryBuf[0] = '\0';

	/* ߂t@C̑gݗ */
	if ((fnbuf = (char *)malloc(strlen(dir_name)+strlen(filename)+1)) == NULL){
		ErrorMessage("Out of memory\n");
		return(-1);
	}
	sprintf(fnbuf,"%s%s",dir_name,filename);

	fpi = fopen(fnbuf,"r");
	free(fnbuf);
	if (fpi == NULL){
		sprintf(msgbuf,"Can't open %s\n",filename);
		ErrorMessage(msgbuf);
		return(-1);
	}

	lineBuf = (unsigned char *)malloc(1024);
	if (lineBuf == NULL){
		ErrorMessage("Out of memory\n");
		
		return -1;
	}

	inHTML = 0;
	/* sPʂœǂݍށB */
	while (1) {
		isEof = fgets(lineBuf,1023,fpi);
		if (isEof == NULL) {
			break;
		}

		/* wb_E{̉\̂ŁA܂s߂sB */
		lineType = parseLine(lineBuf);

		/* s߂̌ʂł̌ςB */
		if (lineType == 1) {
			/* HTMLn܂B */
			inHTML = 1;
		} else if (lineType == 2) {
			/* HTMLIB */
			inHTML = 0;
		} else {
			if (inHTML) {
				result = checkBuf(lineBuf);
				if (result == 2) {
					/* HTMLtitleo炻ŏIB */
					break;
				}
			}
		}
	}

	free(lineBuf);
	fclose(fpi);

	return check_flag;
}

