/*
Local INdex maker "LIN" & "LIN-Win" (C) 1999-2013 Tatsuhiko Shoji
The sources for Local INdex maker "LIN" & "LIN-Win" are distributed under the MIT open source license
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <time.h>
#include	<windows.h>

#include	"lin.h"
#ifdef LINWIN
#include	"linwin.h"
#endif
#include	"encutil.h"

/* (eLXg)t@C̉ */
int CheckTXT(char *dir_name,char *filename)
{
	int c,c2,mode,i,j,skiplen,LangType,istitle;
	FILE *fpi;
	char *fnbuf,msgbuf[300];
	char escbuf[5],isG1;

	//ErrorMessage(filename);
	if ((fnbuf = (char *)malloc(strlen(dir_name)+strlen(filename)+1)) == NULL){
		ErrorMessage("Out of memory\n");
		return(-1);
	}
	sprintf(fnbuf,"%s%s",dir_name,filename);

	fpi = fopen(fnbuf,"r");
	free(fnbuf);
	if (fpi == NULL){
		sprintf(msgbuf,"Can't open %s\n",filename);
		ErrorMessage(msgbuf);
		return(-1);
	}

	istitle = 0;
	mode = 0;
	isG1 = 0;
	while((c = fgetc(fpi)) != EOF){
		if (c == 0x1b){
			escbuf[0] = 0x1b;
			/* ISO-2022-JP(JIS)ǂ̊mF */
			for (j = 0;j < 4;j++){
				escbuf[j+1] = fgetc(fpi);
				if (escbuf[j+1] < 0x20){
					ungetc(escbuf[j+1],fpi);
					break;
				}
				if ((escbuf[j+1] == EOF) || (escbuf[j+1] > 0x2f)){
					break;
				}
			}
			if (j == 4){	// ۂɓǂݍ񂾂Ƃ܂Ŗ߂B
				j = 3;
			}
			LangType = chkISO_2022_JP(escbuf,&skiplen);
			if (LangType == 1){	// double byte mode
				mode = 1;
				isG1 = 0;
			}else if ((LangType == 2) || (LangType == 3)){	// single byte mode
				mode = 0;
				if (LangType == 3){
					isG1 = 1;
				}else{
					isG1 = 0;
				}
			}
			/* ^Cg̏ꍇAobt@Ɋi[B */
			if (istitle){
				titlecpy(0x1b);
				for (i = 0;i <= j;i++){
					titlecpy(escbuf[i+1]);
				}
			}
			continue;
		}else if (c == 0x0e){	// JISpJiJn
			isG1 = 1;
		}else if (c == 0x0f){
			isG1 = 0;
		}

		if (istitle){
			// ^Cg̏ꍇ͉s^CgoIB
			if (c == 0x0d || c == 0x0a){
				terminatetitle();
				break;
			}
		}else{
			// Xy[XȊȌꍇ̓^CgoJnB
			if (!isspace(c)){
				istitle = 1;
			}
		}

		if (mode){	// JIS2oCg[h
			if (istitle){
				titlecpy(c);
			}
			c2 = fgetc(fpi);
			if (c2 != EOF){
				if (istitle){
					titlecpy(c2);
				}
			}
		}else{	// 1oCg
			if (istitle){
				titlecpy(c);
			}
		}
	}
	fclose(fpi);
	terminatetitle();

	return(2);

}

